package extThopt;

import java.util.*; 
import javax.swing.*;

/**
 * classe EHT
 * 
 */
public class EHToutlet extends ExtDivider implements java.awt.event.ActionListener //implements Inversable
{
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField alpha_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField rendement_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField  deltaH_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Tout_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField beta_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField debitmol_value = new javax.swing.JTextField();
	javax.swing.JRadioButton bMode1 = new javax.swing.JRadioButton();
	javax.swing.JRadioButton bMode2 = new javax.swing.JRadioButton();
	final ButtonGroup groupCalcType=new ButtonGroup();
    
    double Pentree,P;
    double msr, nsr, nsortie, Xentree, Tentree, Hentree, fracH2entree, nelectrolysee,nO2;
    String entreeProcess,outletH2Process,outletO2Process,outletH2SubstanceName,outletO2SubstanceName;
    String entreePoint,outletH2Point,outletO2Point;
    rg.corps.Corps outletO2Substance;
    rg.corps.Corps outletH2Substance;
    double flowAirPauvre,flowOutFuel,Minlet;
    Vector outH2H2OComp;
    rg.corps.Corps outletFuelSubstance;
    
        
    String[]gasComp={"H2","H2O"};
    double[]molMass={2.01588,18.01528};
    double O2_M=31.9988;
    
    Vector inputComp;
    double alpha,beta, tau, rendement1, rendement2,deltaH,deltaH0, Q, Hfinal, Tfinal;
    int methode;
    
    public EHToutlet(){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		
		bMode1.setText("calcul avec \u03b1 donn");
		JPanel1.add(bMode1);
		bMode1.setBounds(350,0,150,20);
		bMode2.setText("calcul avec \u0394H donn");
		JPanel1.add(bMode2);
		bMode2.setBounds(350,24,150,20);
	    groupCalcType.add(bMode1);
	    groupCalcType.add(bMode2);
	    bMode1.setSelected(true);
	    bMode1.addActionListener(this);
	    bMode2.addActionListener(this);
		
		JLabel1.setText("fraction molaire de H2 en sortie");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,200,20);
		JPanel1.add(alpha_value);
		alpha_value.setBounds(200,0,124,20);
		alpha_value.setText("0.5");
		JLabel2.setText("rendement en kWh/Nm3 de H2");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,24,200,20);
		JPanel1.add(rendement_value);
		rendement_value.setBounds(200,24,124,20);
		rendement_value.setText("3.2");
		JLabel3.setText("\u0394H apport en kW");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,200,20);
		JPanel1.add(deltaH_value);
		deltaH_value.setBounds(200,48,124,20);
		deltaH_value.setText("0");
		JLabel4.setText("Temprature de sortie (C)");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,200,20);
		JPanel1.add(Tout_value);
		Tout_value.setBounds(200,72,124,20);
		Tout_value.setText("950");
		JLabel5.setText("fraction molaire de H2 en entre");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,96,200,20);
		JPanel1.add(beta_value);
		beta_value.setBounds(200,96,124,20);
		beta_value.setText("0.2");
		JLabel6.setText("dbit molaire d'entre (mol/s)");
		JPanel1.add(JLabel6);
		JLabel6.setBounds(0,120,200,20);
		JPanel1.add(debitmol_value);
		debitmol_value.setBounds(200,120,124,20);
		debitmol_value.setText("30");
		type=getCompType();
		thermoCouplerTypes=new String[0];
        Tout_value.setEditable(false);
        debitmol_value.setEditable(false);
        beta_value.setEditable(false);
    }
    public void init(){
    	    	
	    getDividerStructure();
        checkConsistency();
		}
    
    public String getCompType(){
        return "EHT outlet";
    }
    
	public String getClassDescription(){
	    return "EHT model\n divider\nno thermocoupler\n\nauthor : R. Gicquel Juin 2004\n\nRef : archive EHT.zip";
	}
    
     public void actionPerformed(java.awt.event.ActionEvent e){
        Object o=e.getSource();
        if(o.equals(bMode1)){
            deltaH_value.setEditable(false);
            alpha_value.setEditable(true);
            JPanel1.repaint();
        }
        if(o.equals(bMode2)){
            deltaH_value.setEditable(true);
            alpha_value.setEditable(false);
            JPanel1.repaint();
        }
     }
        
	public void calculateProcess(){
		
		getDividerStructure();
 	    checkConsistency();
 	    
 	    System.out.println("pass 1");
 	    
		//lecture de la fraction molaire de sortie
		alpha=Util.lit_d(alpha_value.getText()); 
		beta=fracH2entree;
		beta_value.setText(Util.aff_d(beta,3));
					
		//calcul du taux de dcomposition de l'eau
		tau=(alpha-fracH2entree)/(1-fracH2entree);
		
		//calcul du rendement en kJ/mol  partir du rendement en kWh/Nm3
		rendement1=Util.lit_d(rendement_value.getText());
		rendement2=rendement1*3600*molMass[0]/(0.08988*1000);
      double ntotSortie=0,outH2H2OM=1;
        if((isBuilt)){//si le noeud externe est bien configur
	        methode=2;
	     	
	     	if(bMode1.isSelected()){//calcul la tranformation  partir du dbit d'entre
	     	
                double molFlow=msr/Minlet;
    	     	
	     	    nsr=molFlow;//
	     	    debitmol_value.setText(Util.aff_d(nsr,3));
	     	    deltaH0=246; //en kJ/mol de H2 produite  900C
	     	    nsortie=nsr;
	     	    nelectrolysee=(alpha-beta)*nsr;
	     	    nO2=nelectrolysee/2;
	     	    deltaH=nelectrolysee*rendement2;
	     	    Q=(deltaH-nelectrolysee*deltaH0)*98/100; // en kW
    	       	
	       	    double nH2sortie=fracH2entree*molFlow+nelectrolysee;
  	       	
	       	    ntotSortie=nsr;
	       	    double xH2=nH2sortie/ntotSortie;
	            outH2H2OComp=initGasComp(gasComp,molMass);
    	       	
                Util.updateMolarComp(outH2H2OComp,gasComp[0], xH2);
                Util.updateMolarComp(outH2H2OComp,gasComp[1], 1.-xH2);
                outletFuelSubstance.updateGasComposition(outH2H2OComp);
                getPointProperties(outletH2Point);
                getSubstProperties(nomCorps);
                outH2H2OM=Msubst;//masse molaire du gaz  traiter
                /*
                System.out.println("ntotSortie : "+ntotSortie);
                System.out.println("nO2 : "+nO2);
                System.out.println("beta : "+beta);
                System.out.println("outH2H2OM : "+outH2H2OM);
	       	    */
                getPointProperties(entreePoint);
                getSubstProperties(nomCorps);
	     	    Hfinal=Hentree+Q/msr*1000;
	       	    Tfinal=lecorps.getT_from_hP(Hfinal,Pentree);
    	     		
	     	    System.out.println(" nentree "+nsr+" nsortie "+nsortie+" Tsortie "+Tfinal+" Hsortie "+Hfinal+" Q "+Q);
	     	
	     		
	     	}
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
	        setupVector(outletH2Process, outletH2Point, 0, ntotSortie*outH2H2OM, Tfinal, Pentree, alpha);
	        setupVector(outletO2Process, outletO2Point, 1, nO2*O2_M, Tfinal, Pentree, 1);
	        setupVector(entreeProcess, entreePoint, 2, msr, Tentree, Pentree, beta);
            updateDivider(vTransfo,vPoints,Tentree,Hentree);
	        deltaH_value.setText(Util.aff_d(deltaH,3));
	        Tout_value.setText(Util.aff_d(Tfinal-273.15,3));
  //   	    System.out.println(" entreeProcess "+entreeProcess+" deltaH "+deltaH+" Q "+Q);
        de.updateProcess(setEnergyTypes(entreeProcess,deltaH-Q,deltaH,0));
		beta_value.setText(Util.aff_d(Q,3));
		 
        }
        
	}
	    public Vector initGasComp(String[]gasComp,double[]molMass){
        int nb_comp=gasComp.length;
        Vector vComp=new Vector();
        Double[]fracMol= new Double[nb_comp],fracMass= new Double[nb_comp],molarMass= new Double[nb_comp];
        for(int j=0;j<nb_comp;j++){
	        fracMol[j]=new Double(0);
	        fracMass[j]=new Double(0);
	        molarMass[j]=new Double(molMass[j]);
        }
        vComp.addElement(new Integer(nb_comp));
        vComp.addElement(gasComp);
        vComp.addElement(fracMol);
        vComp.addElement(fracMass);
        vComp.addElement(molarMass);
        return vComp;
    }
	

        private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        outletO2Process="";
        outletH2Process="";
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 3";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String amont=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(amont);//direct parsing of point property vector
                
                String nom=nomCorps; 
                System.out.println(" ligne "+j+"nomCorps"+nomCorps);
                
                if(nom.equals("O2")){
                    outletO2Process=nomBranche[j];
                    outletO2Point=amont;                
                }
                if(nom.equals("H2_H20mixture2")){
            	    outletH2Process=nomBranche[j];
            	    outletH2Point=amont;   
            	    args=new String[2];
                    args[0]="process";//type of the element (see method getProperties(String[] args))
                    args[1]=outletH2Process;//name of the process (see method getProperties(String[] args))
                    Vector vProp=proj.getProperties(args);
                    amont=(String)vProp.elementAt(1);//gets the upstream point name
                    getPointProperties(amont);//direct parsing of point property vector
	                outletFuelSubstance=lecorps;
            	}
            	
            	}
            	if((outletO2Process.equals(""))|| (outletH2Process.equals(""))){
            	String msg="Error on at least one of the branch substances";
            	JOptionPane.showMessageDialog(de, msg);  
	        	isBuilt=false;
            	}
            }
            
                             
	            entreeProcess=mainProcess;
                System.out.println(" entreeProcess "+entreeProcess);
	            
	    		args[0]="process";//type of the element (see method getProperties(String[] args))
	    		args[1]=entreeProcess;//name of the process (see method getProperties(String[] args))
	    		Vector vPropMain=proj.getProperties(args);
	    		// lecorps=(Corps)vPropMain.elementAt(0);
	    		Double f=(Double)vPropMain.elementAt(3);
	    		msr=f.doubleValue(); //dbit d'entre
	    		String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    		getPointProperties(aval);//direct parsing of point property vector
	    		entreePoint=aval;
	    		Tentree=Tpoint;
	    		Pentree=Ppoint;
	    		Xentree=Xpoint;
	    		Hentree=Hpoint;
	    		getSubstProperties(nomCorps);
	    		inputComp=lecorps.getGasComposition();//composition du gaz d'entre
	    		fracH2entree=Util.molarComp(inputComp,"H2"); //fraction molaire de H2
	    		Minlet=Msubst;
	    		
        		String nom=nomCorps;
        		
        		if(!(nom.equals("H2_H20mixture1"))){
        		    String msg="Error on main process substance, which is "+nomCorps+" instead of H2_H20mixture1";
        		    JOptionPane.showMessageDialog(de, msg);  
	        	isBuilt=false;	
        		}
        
    }

	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "alpha_value");
        if(valeur!=null)alpha=Util.lit_d(valeur);
	    alpha_value.setText(Util.aff_d(alpha,3));
		double deltaH=Util.lit_d(Util.extr_value(ligne_data, "deltaH_value"));
	    deltaH_value.setText(Util.aff_d(deltaH,2));
		double Tfinal=Util.lit_d(Util.extr_value(ligne_data, "Tout_value"));
	    Tout_value.setText(Util.aff_d(Tfinal,2));
		double debitmol=Util.lit_d(Util.extr_value(ligne_data, "debitmol_value"));
	    debitmol_value.setText(Util.aff_d(debitmol,2));
	    valeur=Util.extr_value(ligne_data, "modeCalc");
        if(valeur!=null){
            bMode1.setSelected(Util.lit_b(valeur));
            bMode2.setSelected(!Util.lit_b(valeur));
        }
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"alpha_value="+alpha_value.getText()+tab
	    +"deltaH_value="+deltaH_value.getText()+tab
	    +"Tout_value="+Tout_value.getText()+tab
	    +"debitmol_value="+debitmol_value.getText()+tab
	    +"modeCalc="+Util.aff_b(bMode1.isSelected())+tab
	    ;
        return h;
    }
 
   
}